//+------------------------------------------------------------------+
//|                                                    StepOmaEA.mq4 |
//|                                       Copyright  2016, Steven   |
//|                                http://www.forex-tsd.com          |
//+------------------------------------------------------------------+

#property copyright "Steven"
#property link "http://www.forex-tsd.com"

//|---------This simple ea just for education , you can modify this expert to match your trading style. 

#define EAName "StepOma EA"
enum enIterpolation
{
   int_noint, // No interpolation
   int_line,  // Linear interpolation
   int_quad   // Quadratic interpolation
};

extern int            Magic              = 2016;      //|------------------------magic number
extern string         EntrySetting       = "Step OMA Setting";
extern int            OmaLength          = 25;       // Oma Length
extern double         OmaSpeed           = 2.5;      // Oma Speed
extern bool           OmaAdaptive        = true;     // Use Oma Adaptive true or false
extern double         Sensitivity        = 0.5;      // Sensivity Factor
extern double         StepSize           = 30;       // Step Size period
extern bool           HighLow            = false;    // High/Low Mode Switch (more sensitive)
extern double         Filter             = 0;        // Filter to use for filtering (<=0 - no filtering)
extern double         FilterPeriod       = 0;        // Filter period to use ( when <= 0, same as oma period) 
extern enIterpolation Interpolate        = int_line; // Interpolating method when using multi time frame mode

extern string         PriceFilter         ="Price Filter Setting";
extern int            FastMa              = 5;
extern int            FastMaMode          = 1;
extern int            FastMaPrice         = 6;
extern int            FastMaShift         = 1;
extern int            MAOpenDistance      = 0;

extern string         MMSet               = "Money Management";
extern double         Lots                = 0.01;//|-----------------------lots size
extern bool           RiskMM              = false;//|---------------------risk management
extern double         RiskPercent         = 1;//|------------------risk percentage
extern double         MinLots             = 0.01;//|-------------------minlots
extern double         MaxLots             = 100;//|--------------------maxlots
 int            Slippage            = 100;//|------------------------slippage
 int            MaxOrders           = 1;//|---------------------maximum orders allowed 

extern string         P_LSet              = "Profit & Stop Loss In Point";
extern bool           HideSL              = false;//|---------------------hide stop loss
extern int            StopLoss            = 0;//|------------------------stop loss
extern bool           HideTP              = false;//|---------------------hide take profit
extern int            TakeProfit          = 0;//|----------------------take profit

extern string         Trailing_set        = "Trailing Stop In Point";
extern bool           UseTrailing         = false;   
extern int            TrailingStop        = 0;     
extern int            TrailingStep        = 0; 

extern string         Breakeven_Set       = "Breakeven In Point";    
extern double         Breakevengain       = 0;      
extern double         Breakeven           = 0;

//===================================================================================================================================================
int TimePrev = 0;
double Spread;
double maxEquity,minEquity,Balance=0.0;
bool TradeAsLongAs=false;
bool ClTicket=false;

//===================================================================================================================================================
//
//===================================================================================================================================================
int init()
{
   return(0);
}

//===================================================================================================================================================
//
//===================================================================================================================================================
int deinit()
{
  return(0);
}

//===================================================================================================================================================
//===================================================================================================================================================
int start()
{
//+------------------------------------------------------------------+
//| Trailing Stop                                                    |
//+------------------------------------------------------------------+ 
   if (UseTrailing)MoveTrailingStop();
   
//+------------------------------------------------------------------+
//| BreakEven                                                        |
//+------------------------------------------------------------------+ 
   if(Breakevengain>0)movebreakeven(Breakevengain,Breakeven);    

//+------------------------------------------------------------------+
//| Risk Management                                                  |
//+------------------------------------------------------------------+     
   if(RiskMM)CalculateMM();
   
//+----------------------------------------------------------------------+
//| Check new bar,trade only on new bar                                  |
//+----------------------------------------------------------------------+      
   if (TimePrev == Time[0]) return(0);   
   TimePrev = Time[0];
      
//+------------------------------------------------------------------+
//| Signal Conditions                                                |
//+------------------------------------------------------------------+   
   int limit=1;
   for(int i=1;i<=limit;i++)
   {   
      int y = iBarShift(NULL,0,Time[i]);
      double MA_Signal = iMA(Symbol(),0,FastMa,FastMaShift,FastMaMode,FastMaPrice,0); 
      double TrendCurr = iCustom(Symbol(),0,"step one more average 2.3 mtf",PERIOD_CURRENT,0,OmaLength,OmaSpeed,OmaAdaptive,Sensitivity,StepSize,HighLow,Filter,FilterPeriod,0,0,false,false,false,false,false,false,false,0,11,y);
      double Ma_Bid_Diff = MathAbs(MA_Signal - Bid)/Point;
      bool BUY=false;
      bool SELL=false;
      
      if ( TrendCurr ==1 && Ma_Bid_Diff > MAOpenDistance && Bid > MA_Signal)BUY=true;
      if ( TrendCurr ==-1 && Ma_Bid_Diff > MAOpenDistance && Bid < MA_Signal)SELL=true;

      bool SignalBUY=false;
      bool SignalSELL=false;
      
      if(BUY) SignalBUY=true;
      if(SELL) SignalSELL=true;            
   }
   
//+------------------------------------------------------------------+
//| Open Orders                                                      |
//+------------------------------------------------------------------+      
   double SL,TP,ILots;
   int Ticket;
   if((CountOrders(OP_BUY,Magic)+CountOrders(OP_SELL,Magic))<MaxOrders)
   {  
      if((SignalBUY&&((TradeAsLongAs==false)||(TradeAsLongAs)))||(SignalBUY&&CountOrders(OP_BUY,Magic)<1))
      {
         if(HideSL==false&&StopLoss>0){SL=Ask-StopLoss*Point;}else {SL=0;}
         if(HideTP==false&&TakeProfit>0){TP=Ask+TakeProfit*Point;}else {TP=0;}
         if(ILots<MinLots)ILots=MinLots;if(ILots>MaxLots)ILots=MaxLots;
         
         Ticket=OrderSend(Symbol(),OP_BUY,ILots,Ask,Slippage,SL,TP,EAName,Magic,0,Blue);
      }
      if((SignalSELL&&((TradeAsLongAs==false)||(TradeAsLongAs)))||(SignalSELL&&CountOrders(OP_SELL,Magic)<1))
      {
         if(HideSL==false&&StopLoss>0){SL=Bid+StopLoss*Point;}else {SL=0;}
         if(HideTP==false&&TakeProfit>0){TP=Bid-TakeProfit*Point;}else {TP=0;}
         if(ILots<MinLots)ILots=MinLots;if(ILots>MaxLots)ILots=MaxLots;
         Ticket=OrderSend(Symbol(),OP_SELL,ILots,Bid,Slippage,SL,TP,EAName,Magic,0,Red);
      }
   }

//+------------------------------------------------------------------+
//| Opposite Signal Close                                            |
//+------------------------------------------------------------------+      
   if(SELL)
   {
    CloseBuyOrders(Magic);
   }
   if(BUY)
   {
    CloseSellOrders(Magic);
   }
   
//+------------------------------------------------------------------+
//| hidden sl-tp                                                     |
//+------------------------------------------------------------------+   
   if(HideSL&&StopLoss>0)
   {
      CloseBuyOrdersHiddenSL(Magic);CloseSellOrdersHiddenSL(Magic);
   }
   if(HideTP&&TakeProfit>0)
   {
      CloseBuyOrdersHiddenTP(Magic);CloseSellOrdersHiddenTP(Magic);
   }
   
//+------------------------------------------------------------------+
//| Not Enough Money Warning                                         |
//+------------------------------------------------------------------+
   int err=0;
   if(Ticket<0)
   {
      if(GetLastError()==134)
      {
         err=1;
         Print("Not enough money!");
      }
      return (-1);
   }   

   return(0);
}

//+------------------------------------------------------------------+
//| Close Buy Orders                                                 |
//+------------------------------------------------------------------+
int CloseBuyOrders(int tMagic)
{
  int total=OrdersTotal();

  for (int cnt=total-1;cnt>=0;cnt--)
  {
    if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) 
    if(OrderMagicNumber()==tMagic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_BUY)
      {
       ClTicket= OrderClose(OrderTicket(),OrderLots(),Bid,3);
      }
    }
  }
  return(0);
}

int CloseBuyOrdersHiddenTP(int tMagic)
{
  int total=OrdersTotal();

  for (int cnt=total-1;cnt>=0;cnt--)
  {
    if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) 
    if(OrderMagicNumber()==tMagic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_BUY&&Bid>(OrderOpenPrice()+TakeProfit*Point))
      {
        ClTicket=OrderClose(OrderTicket(),OrderLots(),Bid,3);
      }
    }
  }
  return(0);
}

int CloseBuyOrdersHiddenSL(int tMagic)
{
  int total=OrdersTotal();

  for (int cnt=total-1;cnt>=0;cnt--)
  {
    if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) 
    if(OrderMagicNumber()==tMagic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_BUY&&Bid<(OrderOpenPrice()-StopLoss*Point))
      {
        ClTicket=OrderClose(OrderTicket(),OrderLots(),Bid,3);
      }
    }
  }
  return(0);
}

//+------------------------------------------------------------------+
//| Close Sell Orders                                                |
//+------------------------------------------------------------------+
int CloseSellOrders(int tMagic)
{
  int total=OrdersTotal();

  for(int cnt=total-1;cnt>=0;cnt--)
  {
    if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) 
    if(OrderMagicNumber()==tMagic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_SELL)
      {
        ClTicket=OrderClose(OrderTicket(),OrderLots(),Ask,3);
      }
    }
  }
  return(0);
}


int CloseSellOrdersHiddenTP(int tMagic)
{
  int total=OrdersTotal();

  for(int cnt=total-1;cnt>=0;cnt--)
  {
   if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) 
    if(OrderMagicNumber()==tMagic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_SELL&&Ask<(OrderOpenPrice()-TakeProfit*Point))
      {
        ClTicket=OrderClose(OrderTicket(),OrderLots(),Ask,3);
      }
    }
  }
  return(0);
}

int CloseSellOrdersHiddenSL(int tMagic)
{
  int total=OrdersTotal();

  for(int cnt=total-1;cnt>=0;cnt--)
  {
    if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) 
    if(OrderMagicNumber()==tMagic&&OrderSymbol()==Symbol())
    {
      if(OrderType()==OP_SELL&&Ask>(OrderOpenPrice()+StopLoss*Point))
      {
        ClTicket=OrderClose(OrderTicket(),OrderLots(),Ask,3);
      }
    }
  }
  return(0);
}

//+------------------------------------------------------------------+
//| Count Orders                                                     |
//+------------------------------------------------------------------+
int CountOrders(int Type,int tMagic)
{
   int _CountOrd;
   _CountOrd=0;
   for(int i=0;i<OrdersTotal();i++)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == tMagic)) 
        if ((OrderType() == OP_SELL) || (OrderType() == OP_BUY)) 
         _CountOrd++;

   return(_CountOrd);
}

//+------------------------------------------------------------------+
//| Trailing Stop                                                    |
//+------------------------------------------------------------------+
void MoveTrailingStop()
{
   int i,total=OrdersTotal();
   for(i=0;i<total;i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      if (OrderMagicNumber() != Magic) continue;
      if(OrderType()<=OP_SELL&&OrderSymbol()!=Symbol())  continue;
      {
         if(OrderType()==OP_BUY)
         {
            if(TrailingStop>0&&Bid>(OrderOpenPrice()+(TrailingStop+TrailingStep)*Point))
            {                 
               if((NormalizeDouble(OrderStopLoss(),Digits)<NormalizeDouble(Bid-Point*(TrailingStop+TrailingStep),Digits))||(OrderStopLoss()==0))
               {
                  ClTicket=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-Point*TrailingStop,Digits),OrderTakeProfit(),0,Green);
                  return;
               }
            }
         }
         else 
         {
            if(TrailingStop>0&&Ask<(OrderOpenPrice()-(TrailingStop+TrailingStep)*Point))  
            {                 
               if((NormalizeDouble(OrderStopLoss(),Digits)>(NormalizeDouble(Ask+Point*(TrailingStop+TrailingStep),Digits)))||(OrderStopLoss()==0))
               {
                  ClTicket=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+Point*TrailingStop,Digits),OrderTakeProfit(),0,Red);
                  return;
               }
            }
         }
      }
   }
}

//+------------------------------------------------------------------+
//| BreakEven                                                        |
//+------------------------------------------------------------------+
void movebreakeven(double breakevengain1,double breakeven1)
{
bool ModOrders=false;
   RefreshRates();
   if(OrdersTotal()>0)
   {
      for(int i=OrdersTotal();i>=0;i--)
      {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         {
         if(OrderType()<=OP_SELL && OrderSymbol()!=Symbol() && (OrderMagicNumber() != Magic))continue;
         {
            if(OrderType()==OP_BUY)
            {
               if(NormalizeDouble((Bid-OrderOpenPrice()),Digits)>=NormalizeDouble(breakevengain1*Point,Digits))
               {
                  if((NormalizeDouble((OrderStopLoss()-OrderOpenPrice()),Digits)<NormalizeDouble(breakeven1*Point,Digits)) || OrderStopLoss()==0)
                  {
                     ModOrders=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+breakeven1*Point,Digits),OrderTakeProfit(),0,Blue);
                     return;
                  }
               }
            } else{
               if(NormalizeDouble((OrderOpenPrice()-Ask),Digits)>=NormalizeDouble(breakevengain1*Point,Digits))
               {
                  if((NormalizeDouble((OrderOpenPrice()-OrderStopLoss()),Digits)<NormalizeDouble(breakeven1*Point,Digits)) || OrderStopLoss()==0)
                  {
                     ModOrders=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-breakeven1*Point,Digits),OrderTakeProfit(),0,Red);
                     return;
                     }
                     }
                     }
      }
      }
      }
      }
}

//+------------------------------------------------------------------+
//|  Money Management                                                |
//+------------------------------------------------------------------+      
void CalculateMM()
{
   double tMinLots=MarketInfo(Symbol(),MODE_MINLOT);
   double tMaxLots=MarketInfo(Symbol(),MODE_MAXLOT);
   Lots=AccountFreeMargin()/100000*RiskPercent;
   Lots=MathMin(tMaxLots,MathMax(tMinLots,Lots));
   if(MinLots<0.1)Lots=NormalizeDouble(Lots,2);
   else
   {
     if(tMinLots<1)Lots=NormalizeDouble(Lots,1);
     else Lots=NormalizeDouble(Lots,0);
   }
   if(Lots<tMinLots)Lots=tMinLots;
   if(Lots>tMaxLots)Lots=tMaxLots;
   return;
}

